package org.ap;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import android.app.Activity;
import android.content.Context;
import android.content.res.TypedArray;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.BaseAdapter;
import android.widget.EditText;
import android.widget.Gallery;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

public class CartaProductosActivity extends Activity{
	
	//Imgenes y sus nombres
	Integer[] idsImagenesTablas = { R.drawable.tabla_mojama_atun_barbate, R.drawable.tabla_salmorejo_jamon,
			R.drawable.tabla_samorejo_lomo_mechado, R.drawable.tabla_serena, R.drawable.tabla_coloniales,
			R.drawable.tabla_montanyesa, R.drawable.tabla_duque, R.drawable.tabla_anchoas_cantabrico, R.drawable.tabla_iberica, R.drawable.tabla_campesina};
	List<String> nombresTablas = Arrays.asList("Tabla con Mojama de Atn de Barbate", "Tabla Salmorejo con Jamn",
			"Tabla Salmorejo con Lomo Mechado", "Tabla de la Serena", "Tabla Coloniales", "Tabla Montaesa",
			"Tabla del Duque", "Tabla Anchoas del Cantbrico", "Tabla Ibrica", "Tabla campesina");
	
	Integer[] idsImagenesEnsaladas = { R.drawable.ensalada_salsa_griega, R.drawable.ensalada_arabe,
			R.drawable.ensalada_ahumados, R.drawable.ensalada_queso_cabra};
	List<String> nombresEnsaladas = Arrays.asList("Ensalada Salsa Griega", "Ensalada rabe", "Ensalada de Ahumados",
			"Ensalada de Queso de Cabra");
	
	Integer[] idsImagenesRevueltos = { R.drawable.revuelto_ajetes, R.drawable.revuelto_champinyones,
			R.drawable.revuelto_abuela, R.drawable.revuelto_esparragos_trigueros, R.drawable.revuelto_havas_baby};
	List<String> nombresRevueltos = Arrays.asList("Revuelto de Ajetes", "Revuelto de Championes",
			"Revuelto de la Abuela", "Revuelto de Esprragos Trigueros", "Revuelto de Havas Baby");
	
	Integer[] idsImagenesTapitas = { R.drawable.huevos_codorniz_jamon, R.drawable.huevos_codorniz_chorizo,
			R.drawable.papas_brava, R.drawable.solomillo_whisky, R.drawable.solomillo_roquefort, R.drawable.solomillo_castellana,
			R.drawable.solomillo_oporto, R.drawable.pechuga_salsa_almendras, R.drawable.crujiente_berenjenas_salmorejo,
			R.drawable.cogollos_anchoas_queso, R.drawable.manjar_blanco, R.drawable.berenjenas_rellenas, R.drawable.cuenco_salmorejo,
			R.drawable.roquefort_dulce_moras, R.drawable.pate_pimienta_confituras, R.drawable.pate_pato, R.drawable.surtido_pates};
	List<String> nombresTapitas = Arrays.asList("Huevos de Codorniz con Jamn", "Huevos de Codorniz con Chorizo", "Papas a la Brava",
			"Solomillo al Whisky", "Solomillo al Roquefort", "Solomillo a la Castellana", "Solomillo al Oporto", "Pechuga de Pollo con Salsa de Almendras",
			"Crujiente de Berenjenas con Salmorejo", "Cogollos con Anchoas y Queso", "Manjar Blanco", "Berenjenas Rellenas", 
			"Cuenco de Salmorejo", "Roquefort Dulce con Moras", "Pat a la Pimienta y Confituras", "Pat de Pato", "Surtido de Pats");
	
	Integer[] idsImagenesFritos = { R.drawable.pavia_merluza, R.drawable.tortilla_camarones,
			R.drawable.taquitos_bacalao_frito, R.drawable.chocos, R.drawable.churrasco_ventrasco_atun,
			R.drawable.croquetas_espinacas, R.drawable.calamares_campo};
	List<String> nombresFritos = Arrays.asList("Pava de Merluza", "Tortilla de Camarones", "Taquitos de Bacalao Frito",
			"Chocos Fritos", "Churrasco de Ventresca de Atn", "Croquetas de Espinacas", "Calamares del Campo");
	
	Integer[] idsImagenesChacinas = { R.drawable.queso, R.drawable.jamon,
			R.drawable.carne_mechada};
	List<String> nombresChacinas = Arrays.asList("Queso Viejo de Oveja", "Jamn Ibrico Macerado", "Carne Mechada");
	
	Integer[] idsImagenesCarnes = { R.drawable.punta_solomillo_whisky, R.drawable.punta_solomillo_roquefort,
			R.drawable.punta_solomillo_castellana, R.drawable.punta_solomillo_oporto, R.drawable.pluma_iberica,
			R.drawable.secreto_iberico, R.drawable.churrasco, R.drawable.hamburguesa_antilope, R.drawable.hamburguesa_bisonte,
			R.drawable.entrecot_buey, R.drawable.lomo_buey_marques};
	List<String> nombresCarnes = Arrays.asList("Punta de Solomillo al Whisky", "Punta de Solomillo al Roquefort",
			"Punta de Solomillo a la Castellana", "Punta de Solomillo al Oporto", "Pluma Ibrica", "Secreto Ibrico", 
			"Churrasco", "Hamburguesa de Antlope", "Hamburguesa de Bisonte", "Entrecotte de Buey", "Lomo de Buey al Marqus");
	
	Integer[] idsImagenesPostres = { R.drawable.piononos, R.drawable.tia_pepa,
			R.drawable.tiramisu, R.drawable.tita_margarita};
	List<String> nombresPostres = Arrays.asList("Piononos", "Ta Pepa",
			"Tiramis", "Tita Margarita" );
	
	List<Integer> imagenes = new ArrayList<Integer>();
	List<String> nombres = new ArrayList<String>();

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		
		super.onCreate(savedInstanceState);
		setContentView(R.layout.cartaproductos);
		Gallery gallery = (Gallery) findViewById(R.id.galeria);
		
		//Comprobamos el botn elegido, y establecemos las imgenes de ese tipo
		Bundle bundle = getIntent().getExtras();
        String tipo =  bundle.getString("TIPO");
        //txt.setText("");
        imagenes.clear();
        imagenes = establecerImagenes(tipo);
        nombres = establecerNombres(tipo);
        final TextView txt = (TextView)findViewById(R.id.texto);
        txt.setText("");
        
        //Enlazamos adaptador
		gallery.setAdapter(new ImageAdapter(this));
		gallery.setOnItemClickListener(new OnItemClickListener() {
			//Sale un texto con la imagen seleccionada
			public void onItemClick(AdapterView<?> parent, View v, int position, long id) {
				/*Toast.makeText(getBaseContext(),
						"imagen" + (position + 1) + " seleccionada",
						Toast.LENGTH_SHORT).show();*/
				
				//Mostrar la imagen seleccionada
				ImageView imageView = (ImageView) findViewById(R.id.image);
				imageView.setImageResource(imagenes.get(position));
				txt.setText(nombres.get(position));
				//imageView.setImageResource(IDsimagenes2[position]);
			}
		});
	}

	//Enlaza la galery con las views que deben de mostrar
	public class ImageAdapter extends BaseAdapter {
		
		private Context context;
		private int itemBackground;

		public ImageAdapter(Context c) {
			context = c;
			//Le damos un estilo a la galera
			TypedArray a = obtainStyledAttributes(R.styleable.Galeria1);
			itemBackground = a.getResourceId(R.styleable.Galeria1_android_galleryItemBackground, 0);
			a.recycle();
		}

		//Devolver el nmero de imgenes que se muestran en la galera
		public int getCount() {
			//return IDsimagenes.length;
			return imagenes.size();
		}

		//Devolver la imagen seleccionada
		public Object getItem(int position) {
			return position;
		}

		//Devolver la ID de un item
		public long getItemId(int position) {
			return position;
		}

		//Devolver una view ImageView
		public View getView(int position, View convertView, ViewGroup parent) {
			ImageView imageView = new ImageView(context);
			//Que imagen a mostrar
			//imageView.setImageResource(IDsimagenes[position]);
			imageView.setImageResource(imagenes.get(position));
			//Modo en que se renderizar la imagen
			imageView.setScaleType(ImageView.ScaleType.FIT_XY);
			//Tamao
			imageView.setLayoutParams(new Gallery.LayoutParams(150, 120));
			//Determinar el fondo
			imageView.setBackgroundResource(itemBackground);
			return imageView;
		}
	}
	
	public List<Integer> establecerImagenes(String tipo){
		List<Integer> res = new ArrayList<Integer>();
		int len = 0;
		if(tipo.equals("tablas")){
			len = idsImagenesTablas.length;
			for(int i=0;i<len;i++){
				res.add(idsImagenesTablas[i]);
			}
		}else if(tipo.equals("ensaladas")){
			len = idsImagenesEnsaladas.length;
			for(int i=0;i<len;i++){
				res.add(idsImagenesEnsaladas[i]);
			}
		}else if(tipo.equals("revueltos")){
			len = idsImagenesRevueltos.length;
			for(int i=0;i<len;i++){
				res.add(idsImagenesRevueltos[i]);
			}
		}else if(tipo.equals("tapitas")){
			len = idsImagenesTapitas.length;
			for(int i=0;i<len;i++){
				res.add(idsImagenesTapitas[i]);
			}
		}else if(tipo.equals("fritos")){
			len = idsImagenesFritos.length;
			for(int i=0;i<len;i++){
				res.add(idsImagenesFritos[i]);
			}
		}else if(tipo.equals("chacinas")){
			len = idsImagenesChacinas.length;
			for(int i=0;i<len;i++){
				res.add(idsImagenesChacinas[i]);
			}
		}else if(tipo.equals("carnes")){
			len = idsImagenesCarnes.length;
			for(int i=0;i<len;i++){
				res.add(idsImagenesCarnes[i]);
			}
		}else if(tipo.equals("postres")){
			len = idsImagenesPostres.length;
			for(int i=0;i<len;i++){
				res.add(idsImagenesPostres[i]);
			}
		}
		return res;
	}
	
	public List<String> establecerNombres(String tipo){
		List<String> res = new ArrayList<String>();
		int len = 0;
		if(tipo.equals("tablas")){
			len = nombresTablas.size();
			for(int i=0;i<len;i++){
				res.add(nombresTablas.get(i));
			}
		}else if(tipo.equals("ensaladas")){
			len = nombresEnsaladas.size();
			for(int i=0;i<len;i++){
				res.add(nombresEnsaladas.get(i));
			}
		}else if(tipo.equals("revueltos")){
			len = nombresRevueltos.size();
			for(int i=0;i<len;i++){
				res.add(nombresRevueltos.get(i));
			}
		}else if(tipo.equals("tapitas")){
			len = nombresTapitas.size();
			for(int i=0;i<len;i++){
				res.add(nombresTapitas.get(i));
			}
		}else if(tipo.equals("fritos")){
			len = nombresFritos.size();
			for(int i=0;i<len;i++){
				res.add(nombresFritos.get(i));
			}
		}else if(tipo.equals("chacinas")){
			len = nombresChacinas.size();
			for(int i=0;i<len;i++){
				res.add(nombresChacinas.get(i));
			}
		}else if(tipo.equals("carnes")){
			len = nombresCarnes.size();
			for(int i=0;i<len;i++){
				res.add(nombresCarnes.get(i));
			}
		}else if(tipo.equals("postres")){
			len = nombresPostres.size();
			for(int i=0;i<len;i++){
				res.add(nombresPostres.get(i));
			}
		}
		return res;
	}

}
