package org.ap;

import java.util.ArrayList;
import java.util.List;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;

import android.app.Activity;
import android.app.ProgressDialog;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.widget.Toast;

public class LocalizActivity extends MapActivity{
	
	//Muestra el mapa y sus elementos
	private MapView mapa;
	//Controla el zoom y la posicin del mapa
	private MapController controladorMapa;
	//Lista donde irn los objetos dibujados en el mapa
	private List<Overlay> capas;
	//Para mostrar una ventana de cargando
	private ProgressDialog progressDialog;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	
        super.onCreate(savedInstanceState);
        setContentView(R.layout.localizacion);
        mapa = (MapView) findViewById(R.id.mapview);
        progressDialog = new ProgressDialog(this);
		progressDialog.setTitle("Procesando");
		progressDialog.setMessage("Espere unos segundos...");
        
        //progressDialog.show();
        
        /*new Thread() { 
            public void run() { 
                 try{
                	 mapa.setBuiltInZoomControls(true);
                     controladorMapa = mapa.getController();
                     capas = mapa.getOverlays();
                     OverlayMapa om = new OverlayMapa();
                     capas.add(om);
                     mapa.postInvalidate();
                	//Punto geogrfico especificando latitud y longitud
                     GeoPoint centro = new GeoPoint((int)(37.342523 * 1E6), (int)(-5.841378 * 1E6));
                     //Establecemos el centro del mapa en ese punto
                     controladorMapa.setCenter(centro);
                     //Establecemos un zoom de nivel 14 (vara entre 1 y 21)
                     controladorMapa.setZoom(18); 
                 } catch (Exception e) {  } 
                 // Dismiss the Dialog 
                 progressDialog.dismiss(); 
            } 
       }.start();*/
        
        //Mostramos los controles de zoom sobre el mapa
        mapa.setBuiltInZoomControls(true);
        
        //Controlador
        controladorMapa = mapa.getController();
        
        //Inicializamos. As todo objeto overlay que aadamos a la lista se pintar
        capas = mapa.getOverlays();
        OverlayMapa om = new OverlayMapa();
        capas.add(om);
        mapa.postInvalidate();
        
        //Punto geogrfico especificando latitud y longitud
        GeoPoint centro = new GeoPoint((int)(37.342523 * 1E6), (int)(-5.841378 * 1E6));
        //Establecemos el centro del mapa en ese punto
        controladorMapa.setCenter(centro);
        //Establecemos un zoom de nivel 14 (vara entre 1 y 21)
        controladorMapa.setZoom(18);
        
    }

    //Mtodo para mostrar informacin de la ruta
	@Override
	protected boolean isRouteDisplayed() {
		return true;
	}

}
