package org.ap;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Point;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.google.android.maps.Projection;

public class OverlayMapa extends Overlay{
	
	//Posicin de la marca
	private Double latitud = 37.342607 * 1E6;
    private Double longitud = -5.84147 * 1E6;
    
    @Override
    //Dibuja la marca
    public void draw(Canvas canvas, MapView mapView, boolean shadow){
    	
    	//Objeto para hacer conversiones entre medidas de referencia de x-y a pxeles
        Projection projection = mapView.getProjection();
        GeoPoint geoPoint = new GeoPoint(latitud.intValue(), longitud.intValue());
 
        if (shadow == true){
        	//Hacemos la conversin
            Point centro = new Point();
            projection.toPixels(geoPoint, centro);
 
            //Definimos el pincel de dibujo
            Paint p = new Paint();
            p.setColor(Color.RED);
 
            //Marca Ejemplo 1: Crculo y Texto
            //canvas.drawCircle(centro.x, centro.y, 5, p);
            //canvas.drawText("Bar", centro.x+10, centro.y+5, p);
            
            //Marca Ejemplo 2: Bitmap
            Bitmap bm = BitmapFactory.decodeResource(mapView.getResources(), R.drawable.icono);
            canvas.drawBitmap(bm, centro.x - bm.getWidth(), centro.y - bm.getHeight(), p);
        }
    }

}
