package org.ap;

import java.util.Date;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.RadioGroup;
import android.widget.Spinner;
import android.widget.Toast;
import android.widget.AdapterView.OnItemSelectedListener;

public class Pedido2Activity extends Activity{
	
	private String nom;
	private String tlf;
	private String email;
	private String direccionPedido;
	private String[] horas = {"13","14","15","16","20","21","22","23"};
	private String horaElegida;
	private String[] minutos = {"00","05","10","15","20","25","30","35","40","45","50","55"};
	private String minutosElegido;
	private RadioGroup rg;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.pedido2);
		final Bundle bundle = getIntent().getExtras();
		nom = bundle.getString("Nombre");
		tlf = bundle.getString("Telfono");
		email = bundle.getString("Email");
		
		Button btnPedido2 = (Button)findViewById(R.id.buttonPedido2);
		//RadioButtons
		rg = (RadioGroup)findViewById(R.id.radioDirec);
		rg.check(R.id.radioLocal);
		
		//Apartado de hora y minutos
		Spinner txtHora = (Spinner) findViewById(R.id.spinnerHora);
		txtHora.setOnItemSelectedListener(new OnItemSelectedListener() {
			@Override
			public void onItemSelected(AdapterView<?> arg0, View arg1,
					int arg2, long arg3) {
				int index = arg0.getSelectedItemPosition();
				horaElegida = horas[index];
			}

			@Override
			//Mtodo que se hace al no hacer nada
			public void onNothingSelected(AdapterView<?> arg0) {
				horaElegida = horas[0];
			}
		});
		
		//Apartado de hora y minutos
		Spinner txtMinutos = (Spinner) findViewById(R.id.spinnerMin);
		txtMinutos.setOnItemSelectedListener(new OnItemSelectedListener() {
			@Override
			public void onItemSelected(AdapterView<?> arg0, View arg1,
					int arg2, long arg3) {
				int index = arg0.getSelectedItemPosition();
				minutosElegido = minutos[index];
			}

			@Override
			//Mtodo que se hace al no hacer nada
			public void onNothingSelected(AdapterView<?> arg0) {
				minutosElegido = minutos[0];
			}
		});
		
		//Establecemos el comportamiento del botn
        btnPedido2.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View arg0) {
            	
            	if(falloHora(horaElegida, minutosElegido)){
            		Toast toast = Toast.makeText(getApplicationContext(),
	                        "La hora del pedido ha pasado ya", Toast.LENGTH_LONG);
            		toast.show();
            	}else if(falloTiempoEstimado(horaElegida, minutosElegido)){
            		Toast toast = Toast.makeText(getApplicationContext(),
	                        "Debe de haber 30 minutos entre la hora del pedido y la actual", Toast.LENGTH_LONG);
            		toast.show();
            	}else{
            		int checkedRadioButton = rg.getCheckedRadioButtonId();
                	if(checkedRadioButton != R.id.radioCasa){
                		direccionPedido = "Local";
                	}else{
                		direccionPedido = bundle.getString("Direccin");
                	}
                	
                	bundle.putString("Direccin", direccionPedido);
                	String horaMinuto = horaElegida+":"+minutosElegido;
                	bundle.putString("Hora", horaMinuto);
                	bundle.putString("Nombre", nom);
                	bundle.putString("Telfono", tlf);
                	bundle.putString("Email", email);
                	bundle.putInt("contadorProductos", 0);
                	String[] nombres = new String[20];
                	String[] tipos = new String[20];
                	double[] precios = new double[20];
                	//int[] cantidades = new int[20];
                	bundle.putStringArray("nombresProductos", nombres);
                	bundle.putStringArray("tiposProductos", tipos);
                	bundle.putDoubleArray("preciosProductos", precios);
                	//bundle.putIntArray("cantidadesProductos", cantidades);
                	
                	//Elemento que relaciona a dos actividades
                    Intent intent = new Intent(Pedido2Activity.this, Pedido3Activity.class);
                    intent.putExtras(bundle);
                    startActivity(intent);
            	}
            	
            }
        });
	}
	
	//Comprueba que la hora escogida es correcta
	public boolean falloHora(String hora, String min){
		boolean res = false;
		Date horaActual = new Date();
		int horaNow = horaActual.getHours();
		int minNow = horaActual.getMinutes();
		if(Integer.parseInt(hora) < horaNow && Integer.parseInt(min) < minNow || Integer.parseInt(hora) < horaNow){
			res = true;
		}
		return res;
	}
	
	//Funcin que comprueba que hay un mnimo de 30 minutos entre la hora actual y la hora deseada
	public boolean falloTiempoEstimado(String hora, String min){
		boolean res = false;
		Date horaActual = new Date();
		int horaNow = horaActual.getHours();
		int minNow = horaActual.getMinutes();
		int horaEle = Integer.parseInt(hora);
		int minEle = Integer.parseInt(min);
		int nowEnMinutos = horaNow * 60 + minNow;
		int eleEnMinutos = horaEle * 60 + minEle;
		int diferencia = eleEnMinutos - nowEnMinutos;
		if(diferencia < 30){
			res = true;
		}
		return res;
	}

}
