package org.ap;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.DialogInterface.OnClickListener;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class Pedido4Activity extends Activity{
	
	private String contenido;
	//Para mostrar una ventana de cargando
	private ProgressDialog progressDialog;
	private Mail m;
	private Integer contador;
	private String[] nombres;
	private String[] tipos;
	private double[] precios;
	
	// Creacin de la actividad
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.pedido4);
		
		progressDialog = new ProgressDialog(this);
		progressDialog.setTitle("Procesando");
		progressDialog.setMessage("Espere unos segundos...");
		
		Bundle bundle = getIntent().getExtras();
		contador = bundle.getInt("contadorProductos");
		nombres = bundle.getStringArray("nombresProductos");
		tipos = bundle.getStringArray("tiposProductos");
		precios = bundle.getDoubleArray("preciosProductos");
		
		//Ponemos los datos obtenidos del paso anterior
		TextView txtNombre = (TextView) findViewById(R.id.txtPedidoNombre);
		txtNombre.setText(bundle.getString("Nombre"));
		
		TextView txtTelefono = (TextView) findViewById(R.id.txtPedidoTelefono);
		txtTelefono.setText(bundle.getString("Telfono"));
		
		TextView txtDireccion = (TextView) findViewById(R.id.txtPedidoDireccion);
		txtDireccion.setText(bundle.getString("Direccin"));
		
		TextView txtEmail = (TextView) findViewById(R.id.txtPedidoEmail);
		txtEmail.setText(bundle.getString("Email"));
		
		TextView txtHora = (TextView) findViewById(R.id.txtPedidoHora);
		txtHora.setText(bundle.getString("Hora"));
		
		Button btnCesta = (Button)findViewById(R.id.btnVerPedido);
        //Establecemos el comportamiento del botn
        btnCesta.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View arg0) {
            	Intent intent = new Intent(Pedido4Activity.this, PedidoCestaInfoActivity.class);
                //Para incorporar informacin entre activities
                Bundle bundle = new Bundle();
                bundle.putInt("contadorProductos", contador);
                bundle.putStringArray("nombresProductos", nombres);
                bundle.putStringArray("tiposProductos", tipos);
            	bundle.putDoubleArray("preciosProductos", precios);
            	//bundle.putIntArray("cantidadesProductos", cantidades);
                intent.putExtras(bundle);
                //Lanza la actividad
                startActivity(intent);
            }
        });
		
		//El contenido que vamos a enviar
		contenido = "-Nombre: "+txtNombre.getText()+"\n";
	    contenido = contenido + "-Telfono: "+txtTelefono.getText()+"\n";
	    contenido = contenido + "-Direccin: "+txtDireccion.getText()+"\n";
	    contenido = contenido + "-Email: "+txtEmail.getText()+"\n";
	    contenido = contenido + "-Hora: "+txtHora.getText()+"\n";
	    contenido = contenido + "-Cesta: \n";
	    for(int i=0;i<contador;i++){
	    	contenido = contenido + "\t *"+nombres[i]+"-"+tipos[i]+"\n";
	    }
	    
	    Button btn = (Button)findViewById(R.id.buttonPedir);
        //Establecemos el comportamiento del botn
        btn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View arg0) {
            	//Elemento que relaciona a dos actividades
            	showDialog(0);
            }
        });
        
	}
	
	 @Override
     protected Dialog onCreateDialog(int id){
		 Dialog dialogo;
		 if(id == 0){
			 dialogo = crearDialogoConfirmacion(); 
		 }else{
			 dialogo = crearDialogoAlerta(id);
		 }
            return dialogo; 
     }
	
	private Dialog crearDialogoConfirmacion(){
		
    	AlertDialog.Builder builder = new AlertDialog.Builder(this);
    	
    	builder.setTitle("Confirmacin");
    	builder.setMessage("Confirmas el pedido?");
    	builder.setPositiveButton("Aceptar", new OnClickListener() {
			public void onClick(DialogInterface dialog, int which) {
				//Log.i("Dialogos", "Confirmacion Aceptada.");
				dialog.cancel();
				/*m = new Mail();
				m.setAsunto("Pedido");
				m.setBody(contenido);
				try{
					progressDialog.show();
					new Thread() { 
			            public void run() { 
			                 try{ 
			                      m.sendEmail(); 
			                 } catch (Exception e) {  } 
			                 // Dismiss the Dialog 
			                 progressDialog.dismiss(); 
			            } 
			       }.start();
					m.sendEmail();
				}catch(Exception e){
					showDialog(2);
				}*/
				tramitarPedido();
				showDialog(1);
				
			}
		});
    	builder.setNegativeButton("Cancelar", new OnClickListener() {
			public void onClick(DialogInterface dialog, int which) {
				//Log.i("Dialogos", "Confirmacion Cancelada.");
				dialog.cancel();
			}
		});
    	
    	return builder.create();
    }
	
	private void tramitarPedido(){
		m = new Mail();
		m.setAsunto("Pedido");
		m.setBody(contenido);
		try{
			progressDialog.show();
			new Thread() { 
	            public void run() { 
	                 try{ 
	                     m.sendEmail(); 
		                 progressDialog.dismiss();
	                 } catch (Exception e) {  }  
	            } 
	       }.start();
		//m.sendEmail();
		}catch(Exception e){
			showDialog(2);
		}
		showDialog(1);
	}
	
	private Dialog crearDialogoAlerta(int id){
		
    	AlertDialog.Builder builder = new AlertDialog.Builder(this);
    	
    	if(id == 1){
    		builder.setTitle("xito");
        	builder.setMessage("El pedido se ha enviado correctamente.");
        	builder.setPositiveButton("OK", new OnClickListener() {
    			public void onClick(DialogInterface dialog, int which) {
    				dialog.cancel();
    				Intent intent = new Intent(Pedido4Activity.this, AppAndroidActivity.class);
                    startActivity(intent);
    			}
    		});
    	}else{
    		builder.setTitle("Error");
        	builder.setMessage("No se ha podido enviar el pedido. Intntelo ms tarde.");
        	builder.setPositiveButton("OK", new OnClickListener() {
    			public void onClick(DialogInterface dialog, int which) {
    				dialog.cancel();
    			}
    		});
    	}
    	return builder.create();
    }

}
