package org.ap;

import java.util.Calendar;

import android.app.Activity;
import android.app.DatePickerDialog;
import android.app.Dialog;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

public class ReservaActivity extends Activity {

	private TextView textoFecha;
	private Button buttonFecha;
	private Button buttonReserva;
	
	private int year;
	private int month;
	private int day;
	// Constante usada para el display de la fecha
	static final int DATE_DIALOG_ID = 0;
	
	private String numComensales;
	private String horaElegida;

	// Creacin de la actividad
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.reserva);
		
		final Calendar c = Calendar.getInstance();
		year = c.get(Calendar.YEAR);
		month = c.get(Calendar.MONTH);
		day = c.get(Calendar.DAY_OF_MONTH);
		
		//Establece la fecha de hoy
		setCurrentDateOnView();
		//Aade comportamiento al botn de cambiar la fecha
		addListenerOnButton();
		
		Spinner txtComensales = (Spinner) findViewById(R.id.spinnerCom);
		numComensales = "1";
		txtComensales.setOnItemSelectedListener(new OnItemSelectedListener() {
			@Override
			public void onItemSelected(AdapterView<?> arg0, View arg1,
					int arg2, long arg3) {
				int index = arg0.getSelectedItemPosition();
				numComensales = Integer.toString(index+1);
				//numComensales = Integer.toString(arg2+1);
				/*Toast toast = Toast.makeText(getApplicationContext(),
                        "Cambio", Toast.LENGTH_LONG);
				toast.show();*/
			}

			@Override
			//Mtodo que se hace al no hacer nada
			public void onNothingSelected(AdapterView<?> arg0) {
			}
		});
		
		Spinner txtHora = (Spinner) findViewById(R.id.spinnerHora);
        horaElegida = "Almuerzo";
        txtHora.setOnItemSelectedListener(new OnItemSelectedListener() {
			@Override
			public void onItemSelected(AdapterView<?> arg0, View arg1,
					int arg2, long arg3) {
				int index = arg0.getSelectedItemPosition();
				/*Toast toast = Toast.makeText(getApplicationContext(),
                        "Cambio", Toast.LENGTH_LONG);
				toast.show();*/
				if(index == 0){
					horaElegida = "Almuerzo";
				}else{
					horaElegida = "Cena";
				}
			}

			@Override
			//Mtodo que se hace al no hacer nada
			public void onNothingSelected(AdapterView<?> arg0) {
			}
		});
		
		//Establecemos el comportamiento del botn reservar
		buttonReserva = (Button) findViewById(R.id.buttonReservar);
		buttonReserva.setOnClickListener(new OnClickListener() {
		    public void onClick(View v) {
		    	
		        //Obtenemos los datos para el envo del correo
		        EditText txtNombre = (EditText) findViewById(R.id.txtNombre);
		        EditText txtTelefono = (EditText) findViewById(R.id.txtTelefono);
		        EditText txtEmail = (EditText) findViewById(R.id.txtEmail);
		        TextView txtFecha = (TextView) findViewById(R.id.textFecha);
		        EditText txtComment = (EditText) findViewById(R.id.txtComment);
		        
		        String nombre = txtNombre.getText().toString();
		        String telefono = txtTelefono.getText().toString();
		        String email = txtEmail.getText().toString();
		        String fecha = txtFecha.getText().toString();
		        String comentarios = txtComment.getText().toString();
		        
		        if(nombre.isEmpty()){
		        	Toast toast = Toast.makeText(getApplicationContext(),
		                        "El campo nombre no ha sido rellenado", Toast.LENGTH_LONG);
		            toast.show();
		        }else if(telefono.isEmpty()){
		        	Toast toast = Toast.makeText(getApplicationContext(),
	                        "El campo telfono no ha sido rellenado", Toast.LENGTH_LONG);
		        	toast.show();
		        }else if(telefono.length() != 9){
		        	Toast toast = Toast.makeText(getApplicationContext(),
	                        "El campo telfono debe tener 9 cifras numricas", Toast.LENGTH_LONG);
		        	toast.show();
		        }else if(email.isEmpty()){
		        	Toast toast = Toast.makeText(getApplicationContext(),
	                        "El campo email no ha sido rellenado", Toast.LENGTH_LONG);
		        	toast.show();
		        }else if(!email.contains(".") || !email.contains("@")){
			        	Toast toast = Toast.makeText(getApplicationContext(),
		                        "El campo email no es correcto", Toast.LENGTH_LONG);
			        	toast.show();
		        }else{
		        	//Para redirigir a la siguiente pantalla
	                Intent intent = new Intent(ReservaActivity.this, Reserva2Activity.class);
	                //Para incorporar informacin entre activities
	                Bundle bundle = new Bundle();
	                bundle.putString("Nombre", nombre);
	                bundle.putString("Telfono", telefono);
	                bundle.putString("Email", email);
	                bundle.putString("NumComensales", numComensales);
	                bundle.putString("Fecha", fecha);
	                bundle.putString("Hora", horaElegida);
	                bundle.putString("Comentarios", comentarios);
	                intent.putExtras(bundle);
			        //iniciamos la actividad
			        startActivity(intent);
		        }
		    }
		});
		
	}
	
	//Pone en la pantalla la fecha de hoy
	public void setCurrentDateOnView() {
 
		textoFecha = (TextView) findViewById(R.id.textFecha);
		//Establecemos en el texto la fecha
		textoFecha.setText(new StringBuilder()
			// Month is 0 based, just add 1
			.append(day).append("/").append(month + 1).append("/")
			.append(year).append(" "));
 
	}
	
	//Mtodo que establece el comportamiento del botn establecer la fecha
	public void addListenerOnButton() {
		buttonFecha = (Button) findViewById(R.id.buttonFecha);
		buttonFecha.setOnClickListener(new View.OnClickListener() {
 
			@Override
			public void onClick(View v) {
				showDialog(DATE_DIALOG_ID);
			}
		});
	}
	
	@Override
	protected Dialog onCreateDialog(int id) {
		switch (id) {
		case DATE_DIALOG_ID:
			return new DatePickerDialog(this, mDateSetListener, year, month,day);
		}
		return null;
	}
	
	// Cuando modificamos la fecha
	private DatePickerDialog.OnDateSetListener mDateSetListener = new DatePickerDialog.OnDateSetListener() {
		public void onDateSet(DatePicker view, int yeard, int monthOfYear, int dayOfMonth) {
			year = yeard;
			month = monthOfYear;
			day = dayOfMonth;
			setCurrentDateOnView();
		}
	};

}
